local GAME_GRID = {
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
}

local POINTS_DISTANCE = 20
local FIRST_POINTPOSX = 5
local FIRST_POINTPOSY = 5

function love.update()
end

function love.draw()
    drawGrid()
end

function love.mousepressed(x, y, button)
    if button == "l" then
        gridInsert(x, y)
    end
end

function drawGrid()
    for y, xtab in ipairs(GAME_GRID) do
        for x, value in ipairs(xtab) do
            love.graphics.setColor(255, 255, 255)
            if value == 1 then
                local check = checkAround(x, y)
                for _, t in ipairs(check) do
                    love.graphics.line((x-1)*POINTS_DISTANCE+FIRST_POINTPOSX, (y-1)*POINTS_DISTANCE+FIRST_POINTPOSY, (t[1]-1)*POINTS_DISTANCE+FIRST_POINTPOSX, (t[2]-1)*POINTS_DISTANCE+FIRST_POINTPOSY)
                end
                love.graphics.setColor(255, 0, 0)
            end
            love.graphics.circle("fill", (x-1)*POINTS_DISTANCE+FIRST_POINTPOSX, (y-1)*POINTS_DISTANCE+FIRST_POINTPOSY, 2, 30)
        end
    end
end

function gridInsert(x, y)
    local px = math.floor((x+FIRST_POINTPOSX)/POINTS_DISTANCE)+1
    local py = math.floor((y+FIRST_POINTPOSY)/POINTS_DISTANCE)+1
    if GAME_GRID[py] and GAME_GRID[py][px] then
        if GAME_GRID[py][px] == 0 then 
            GAME_GRID[py][px] = 1
        else
            GAME_GRID[py][px] = 0
        end
    end
end

function checkAround(px, py)
    local dirs = {
    [1] = {0, -1},
    [2] = {1, -1},
    [3] = {1, 0},
    [4] = {1, 1},
    [5] = {0, 1},
    [6] = {-1, 1},
    [7] = {-1, 0},
    [8] = {-1, -1},
    [9] = {-2, -2},
    [10] = {-1, -2},
    [11] = {0, -2},
    [12] = {1, -2},
    [13] = {2, -2},
    [14] = {2, -1},
    [15] = {2, 0},
    [16] = {2, 1},
    [17] = {2, 2},
    [18] = {1, 2},
    [19] = {0, 2},
    [20] = {-1, 2},
    [21] = {-2, 2},
    [22] = {-2, 1},
    [23] = {-2, 0},
    [24] = {-2, -1},
    }
    local ret = {}
    
    for i = 1, 24 do
        local npx, npy = px+dirs[i][1], py+dirs[i][2]
        if GAME_GRID[npy] and GAME_GRID[npy][npx] and GAME_GRID[npy][npx] == 1 then
            table.insert(ret, {npx, npy})
        end
    end
    return ret
end